Subject: Re: [PATCH iproute2-next] Improve batch times by caching link lookups

From: Stephen Hemminger <[email-masked]>
Date: Mon, 7 Jan 2019 13:31:55 -0800

On Mon,  7 Jan 2019 12:41:30 -0800
David Ahern <[email-masked]> wrote:

> From: David Ahern <[email-masked]>
> 
> ip route uses ll_name_to_index to convert the user given device name to an
> index. At the moment ll_name_to_index uses if_nametoindex which is ioctl
> based and does not cache the result. When using a batch file this means
> the same device lookups can be done repeatedly adding unnecessary overhead
> (socket + ioctl call for each device lookup).
> 
> Add a new function, ll_link_get, to send a netlink based RTM_GETLINK. If
> successful, cache the result in idx_head and name_head so future lookups
> can re-use the entry.
> 
> With this change the time to install routes via a batch file is reduced
> from 30.7 seconds to 17.6 seconds (720,022 routes with 2 ecmp nexthops
> where the nexthop device is given).
> 
> Signed-off-by: David Ahern <[email-masked]>

What if a ip command in the batch does a rename?